#include<math.h>
#include<stdio.h>

typedef struct
{
   char nome;
   float x,y,z;
} TForca;

TForca cadastrarForca(void)
{
   TForca res;
   printf("Nome da forca: ");
   scanf("%c", &res.nome);
   scanf("%c", &res.nome);
   printf("Componentes da forca: ");
   scanf("%f", &res.x);
   scanf("%f", &res.y);
   scanf("%f", &res.z);
   return res;
}

void imprimirForca(TForca f)
{
   float m;
   m=sqrt(f.x*f.x+f.y*f.y+f.z*f.z);
   printf("Forca %c: (%.2f,%.2f,%.2f). Modulo=%.2f\n",f.nome,f.x,f.y,f.z,m);
}

void imprimirTodasForcas(TForca forcas[10], int n)
{
   int i;
   for(i=0; i<n; i++)
   {
      imprimirForca(forcas[i]);
   }
}

void calcularForcaResultante(TForca forcas[10], int n)
{
   int i;
   float resx, resy, resz;
   resx=0;
   resy=0;
   resz=0;
   for (i=0; i<n; i++)
   {
      resx = resx + forcas[i].x;
      resy = resy + forcas[i].y;
      resz = resz + forcas[i].z;
   }
   printf("Forca resultante: (%.2f,%.2f,%.2f)\n",resx,resy,resz);
   if (resx == 0 && resy == 0 && resz == 0)
   {
      printf("Equilibrio!\n");
   }
}

void salvarForcas(TForca forcas[10], int n)
{
   FILE *arq;
   arq = fopen("forcas.bin", "wb");

   if (arq != NULL)
   {
      fwrite(&n, sizeof(int), 1, arq);
      fwrite(forcas, sizeof(TForca), n, arq);
      fclose(arq);
   }
}

void pegarForcas(TForca forcas[10], int *n)
{
   FILE *arq;

   arq = fopen("forcas.bin", "rb");

   if (arq != NULL)
   {
      fread(n, sizeof(int), 1, arq);
      fread(forcas, sizeof(TForca), *n, arq);
      fclose(arq);
   }
}

int main(void)
{
   TForca forcas[10];
   int esc,i,n;

   n=0;
   do
   {
      for (i=0; i<30; i++)
      {
         printf("-");
      }
      printf("\n");
      printf("Calculo de forcas\n");
      printf("1- Adicionar uma forca\n");
      printf("2- Imprimir as forcas\n");
      printf("3- Imprimir todas as forcas\n");
      printf("4- Calcular forca resultante\n");
      printf("5- Salvar as forcas\n");
      printf("6- Pegar as forcas\n");
      printf("0- Sair\n");
      printf(">");
      scanf("%d", &esc);
      switch(esc)
      {
         case 1:
            if (n<10)
            {
               forcas[n] = cadastrarForca();
               n++;
            }
            else
            {
               printf("Erro: Quantitade maxima de forcas ja atingidas\n");
            }
            break;
         case 2:
            if (n>0)
            {
               do
               {
                  printf("Qual forca? (0-%d): ",n-1);
                  scanf("%d", &i);
               }
               while (i<0 || i>=n);
               imprimirForca(forcas[i]);
            }
            else
            {
               printf("Erro: Nenhum forca cadastrada\n");
            }
            break;
         case 3:
            imprimirTodasForcas(forcas,n);
            break;
         case 4:
            calcularForcaResultante(forcas,n);
            break;
         case 5:
            salvarForcas(forcas,n);
            break;
         case 6:
            pegarForcas(forcas, &n);
            break;
         case 0:
            break;
         default:
            printf("Erro: Escolha invalida\n");
            break;
      }
   }
   while (esc != 0);

   return 0;
}
